import { world, Player } from "@minecraft/server"
import { configPanel } from "../functions/config"
import { apiConfig } from "../lib/player/config"

world.afterEvents.itemUse.subscribe(({source: entity, itemStack: item}) => {
  const player = entity as Player
  if(!player.isSneaking) return
  if(!item.getTags().includes("minecraft:is_pickaxe")) return
  if(player.getBlockFromViewDirection({maxDistance: 10})){
    if(apiConfig.get(player).quick) quickSettings(player)
    return // quickSettings(player)
  }
  configPanel.open(player)
})

function quickSettings(player: Player): void {
  const config = apiConfig.get(player)
  const nextState = functionList.findIndex(value => value == config.functionType) +1
  const func = functionList[nextState >= functionList.length ? 0 : nextState]
  config.functionType = func as typeof functionList[number]
  player.sendMessage({"rawtext":[{"translate": "warning.veinminer:quick_setting"}, {"translate": `ui.veinminer:config.function_type.${func}`}]})
  return apiConfig.set(player, config)
}

const functionList = ["off", "all", "3x3_tunnel", "mining_tunnel", "escape_tunnel"] as const