import { world, BlockPermutation, Block } from "@minecraft/server"
import { BlockStateSuperset } from "@minecraft/vanilla-data"

export const apiState = new class apiState {
  get(block: Block, id: string): string | number | boolean | undefined {
    return block.permutation.getState(id as keyof BlockStateSuperset)
  }

  getAll(block: Block): Record<string, boolean | number | string> {
    return block.permutation.getAllStates()
  }

  set(block: Block, id: string, value: string | number | boolean): void {
    const states = this.getAll(block)
    states[id] = value
    block.setPermutation(BlockPermutation.resolve(block.typeId, states))
  }
}