import { world, ItemStack, EquipmentSlot, Player } from "@minecraft/server"
import { apiEquippable } from "../player/equippable"
import { apiNumbers } from "../math/numbers"

export const apiItemDurability = new class apiItemDurability {
  remove(player: Player, item: ItemStack, damage = 1): void {
    if(player.getGameMode() == "creative") return
    const enchantment = item.getComponent("enchantable")
    if(enchantment){
      const unbreaking = enchantment.getEnchantment("minecraft:unbreaking")
      if(unbreaking){
        const tryDamage = Math.floor(damage * ((100/(unbreaking.level + 1))/100)) +1
        damage = apiNumbers.clamp(Math.floor(apiNumbers.random({min: tryDamage *0.5, max: tryDamage *1.5})), 0, tryDamage *1.5)
      }
    }
    const durability = item.getComponent("durability")
    if(!durability) return
    if(durability.damage + damage >= durability.maxDurability){
      player.playSound("random.break")
      return apiEquippable.setItem(player, undefined, EquipmentSlot.Mainhand)
    }
    durability.damage += damage
    apiEquippable.setItem(player, item, EquipmentSlot.Mainhand)
  }
}