import { world, Player } from "@minecraft/server"

export const apiConfig = new class apiConfig {
  get(player: Player): configInfo {
    const config = player.getDynamicProperty("veinminer:config_info")
    if(typeof config != "string") return defaultConfig
    return JSON.parse(config)
  }

  set(player: Player, config: configInfo): void {
    player.setDynamicProperty("veinminer:config_info", JSON.stringify(config))
  }
}

export const defaultConfig: configInfo = {
  showSelection: false,
  functionType: "all",
  maxSize: 64,
  quick: false
} as const

export interface configInfo {
  showSelection: boolean,
  functionType: "off" | "all" | "3x3_tunnel" | "mining_tunnel" | "escape_tunnel",
  maxSize: number,
  quick: boolean
}